#!/usr/bin/perl -w

################################################################################
# Name:        AdminPublish.pl
# Version:     1.1
# Author:      Reinhard E. Voglmaier
#              GlaxoWellcome
#              rv33100@GlaxoWellcome.co.uk
# Date:        12.04.2000
# Description: Publisher Administration
# Copyright:   GPL
################################################################################
push(@INC,".." );
require "adminDB.pm" ;

use CGI;

$Query = new CGI ;
$writable = "yes" ;
&open_databases($writable);

$UID_Publisher=$ENV{'REMOTE_USER'} || "Not defined" ;


print $Query->header(-expires=>'+1h');
print $Query->start_html(-title=>'Publisher Administration',
                         -author=>'rv33100@glaxowellcome.co.uk',
                         -onUnload=>'clean();',
                         -onLoad=>'SortArrays();',
                         -script=>{ -language => 'JavaScript',
                                    -src=>'./AdminPublish.js' },
                        );
print "<CENTER><H2>Publisher Administration</H2></CENTER>";
print $Query->start_multipart_form(-name=>'AdminPublisher');

print $Query->scrolling_list(-name=>   'ScrollInodeList',
                             -values=> ['DUMMYDUMMYDUMMYDUMMYDUMMYDUMMYDUMMYDUMMY'],
                             -override=>1,
                             -onChange=> 'displaySelectedInode(ScrollInodeList[ScrollInodeList.selectedIndex]);' ,
                             -size=>   5 ) ;
print "<BR>";

print "<PRE>";
print "Modification Date : " ;
print $Query->textfield(-name=>'ModDate',
                        -override=>1,
                        -onfocus=>'ReadOnly(this);',
                        -size=>24,
                        -maxlenght=>10
                        );
print "  Type              : " ;
print $Query->textfield(-name=>'Type',
                        -override=>1,
                        -onfocus=>'ReadOnly(this);',
                        -size=>10,
                        -maxlenght=>10
                        );
print "<BR>";
print "Name              : " ;
print $Query->textfield(-name=>'UserId',
                        -override=>1,
                        -onfocus=>'ReadOnly(this);',
                        -size=>10,
                        -maxlenght=>10
                        );
print "<BR>";
print "</PRE>";

print $Query->hr();
print $Query->scrolling_list(-name=>   'ScrollUserList',
                             -values=> ['**********'],
                             -onChange=> 'displaySelectedUser(ScrollUserList[ScrollUserList.selectedIndex]);',
                             -override=>1,
                             -size=>   5 ) ;
print $Query->scrolling_list(-name=>   'DocumentList',
                             -values=> ['DUMMYDUMMYDUMMYDUMMYDUMMYDUMMYDUMMYDUMMY'],
                             -override=>1,
                             -size=>   5 ) ;
print "<BR>";
print "                    " ;
print $Query->textfield(-name=>'UserName',
                        -override=>1,
                        -size=>20,
                        -maxlenght=>30
                        );
print $Query->button(-name=>'AddUser',
                     -value=>'Add User',
                     -onclick=>'DBaddUser();return true;'
                    );
print $Query->button(-name=>'ModifyUser',
                     -value=>'Modify User',
                     -onclick=>'DBmodifyUser(ScrollUserList[ScrollUserList.selectedIndex]);return true;'
                    );
print $Query->button(-name=>'DeleteUser',
                     -value=>'Delete User',
                     -onclick=>'DBdeleteUser(ScrollUserList[ScrollUserList.selectedIndex]);return true;'
                    );
print $Query->button(-name=>'CloseThis',
                     -value=>'Close',
                     -onClick=>'window.close();return true'
                    );

 
&loadInodes();
&loadUserList();

&close_databases();
print $Query->endform();
print $Query->end_html();




sub loadInodes {
    my $DirName ;
    &JS_Open();
    printf("InitForm();\n");

    foreach $DirName ( sort &getDirKeys() ) {
        my ($Type,$Date,$UserId) = getDirEntry($DirName) ;
        printf("addInode('%s','%s','%s','%s');" ,$DirName,$Type,$Date,$UserId) ;
    }
    &JS_Close();
    print "\n" ;
}

sub loadUserList {
    my $UserId ;
    &JS_Open();
    foreach $UserId ( sort &getAccessKeys() ) {
       my @DirList = getAccessEntry($UserId) ;
       my $Dirs = join(";;",@DirList);
       printf("addUser('%s','%s','%s');",$UserId,getUserName($UserId),$Dirs) ;
    }
    &JS_Close();
}

sub JS_Open {
    print "<SCRIPT LANGUAGE='JavaScript'> " ;
}


sub JS_Close {
    print "</SCRIPT>" ;
}

