#!/usr/local/bin/perl

# bounce jobs to different printers in the bank on either a random basis
# or based on which one is listening.

$CONFIGDIR = "/usr/site/mdriver/etc/";
$CONNECTPORT = 9100;
$NOTIFY = "wymanm\@rice.edu";

$bank = $ARGV[0];

$configfile = $CONFIGDIR . $bank;

open IFILE, "< $configfile" or die;

while (<IFILE>) {
    if (/^#/ || /^\n/) {
	# ignore comment lines
	next;
    }
    # bank file format:
    # subptr|hostname:subptr|hostname:subptr|hostname
    chomp;
    (@printers) = split/:/;
}

close IFILE;

$count = $#printers + 1;

$random = int(rand($count * 100000));

$printer = int ($random / 100000);
($queue, $hostname) = split/\|/, $printers[$printer];

$i = system("/usr/sbin/ping $hostname 3 > /dev/null 2>&1");

# if the response is 0, the printer is at least pingable.  send the job
if ($i == 0) {
    print "dest $queue\@localhost\n";
    print "copies 1\n";
    print "end\n";
    exit (0);
}

# if no answer, grab the next printer in the bank and send the job
# there.  if the whole bank is down, better that the job get queued somewhere
# than we hang around and cause it to be held in a bounce queue

$deadhost = $hostname;

if ($printer == $#printers) {
    ($queue, $hostname) = split/\|/, $printers[0];
    print "dest $queue\@localhost\n";
    print "copies 1\n";
    print "end\n";
} else {
    ($queue, $hostname) = split/\|/, $printers[$printer + 1];
    print "dest $queue\@localhost\n";
    print "copies 1\n";
    print "end\n";
}

$cmd = "| /usr/ucb/mail -s \"printer not responding\" $NOTIFY";
open PIPE, $cmd or die "cannot fork\n";
print PIPE "Unable to connect to printer $deadhost\n";
print PIPE "Diverting job to alternate printer: $queue\n";
close PIPE;
exit(0);


